//**************************************************************************
// ﾌｧｲﾙ内容     「aqm1248graphic.ino」グラフィック液晶AQM1248の制御(グラフィック)(RMC-RA4M1 rev.2.0)
// Copyright    ジャパンマイコンカーラリー実行委員会
// ライセンス   This software is released under the MIT License.
//              http://opensource.org/licenses/mit-license.php
//**************************************************************************

// インクルード宣言
#include <MGLCD.h>            // 出典；しなぷすのハード製作記　https://synapse.kyoto/lib/MGLCD/page001.html
#include <MGLCD_SPI.h>
#include <SPI.h>

// グローバル変数の宣言
ArduinoSPI SPI(MISO, MOSI, SCK, FORCE_SPI_MODE);            // Arduino UNO R4のSPIを使用(MISO=12,MOSI=11,SCK=13)
MGLCD_AQM1248A_SPI MGLCD( MGLCD_SpiPin2(10, 9), 100000L );  // (10=CSピン,9=RSピン), MAX_FREQの設定

void setup()
{
  // LCDの初期化
  while( MGLCD.Reset() );         // CS=10pin  RS=9pin  SCLK=13pin  SDI=11pin
  if( strlen("ｱ") != 1 ) MGLCD.SetCodeMode( MGLCD_CODE_UTF8 );  // 半角カナ表示の有効化
  MGLCD.SetVolumeResistor( 28 );  // コントラストの調整 0～63
  MGLCD.ClearScreen();
}

void loop()
{
  // 点を打つ
  MGLCD.SetPixel( 10, 10 );         // x , y , color(1:点灯 0:消灯 省略時は1になる) 
  MGLCD.SetPixel( 11, 11 );
  MGLCD.SetPixel( 12, 12 );
  delay( 500 );

  // 線を引く
  MGLCD.Line( 20, 10, 20, 40 );     // 始点x , 始点y , 終点x , 終点y , color(1:点灯 0:消灯 省略時は1になる)
  delay( 500 );

  // 長方形を描く(塗りつぶし無し)
  MGLCD.Rect( 30, 10, 40, 20 );     // 始点x , 始点y , 終点x , 終点y , color(1:点灯 0:消灯 省略時は1になる)
  delay( 500 );

  // 長方形を描く(塗りつぶし有り)
  MGLCD.FillRect( 50, 30, 60, 40 ); // 始点x , 始点y , 終点x , 終点y , color(1:点灯 0:消灯 省略時は1になる)
  delay( 500 );

  // 円を描く(塗りつぶし無し)
  MGLCD.Circle( 80, 20, 10 );       // x , y , 半径r , color(1:点灯 0:消灯 省略時は1になる) 
  delay( 500 );

  // 円を描く(塗りつぶし有り)
  MGLCD.FillCircle( 110, 20, 10 );  // x , y , 半径r , color(1:点灯 0:消灯 省略時は1になる) 
  delay( 5000 );

  MGLCD.ClearScreen();              // 画面クリア
  delay( 500 );
}