//**************************************************************************
// ﾌｧｲﾙ内容     「eeprom.ino」データフラッシュメモリ(EEP-ROM)に保存、読み込み(RMC-RA4M1 rev.2.0)
// Copyright    ジャパンマイコンカーラリー実行委員会
// ライセンス   This software is released under the MIT License.
//              http://opensource.org/licenses/mit-license.php
//**************************************************************************
/*
※RAマイコンは、EEP-ROMのことを、データフラッシュメモリと呼びます。
  標準で1,000,000回（最低保障回数100,000回）、書き込みを行うことができます。
*/

// インクルード
#include <EEPROM.h>

// シンボル定義
#define EEPROM_CHECK ((int)0x20240201)  // EEP-ROMにデータが書き込まれているかチェック用

void setup() {
  int i;

  Serial.begin(9600);
  while ( !Serial ) {
    // 接続されるまで待つ
  }

  EEPROM.get( 0, i ); // 0番地から値読み込み

  if( i != EEPROM_CHECK ) {
    //もしデータ書き込まれていないなら
    Serial.print( "初めての使用と判断し、EEP-ROMを初期化します...　" );
    EEPROM.put( 0 , EEPROM_CHECK ); // 0番地　チェック用データ　書き込み
    EEPROM.put( 4 , (int)1 );       // 4番地　データ　書き込み
    Serial.println( "初期化しました。" );
  }
  // データが書き込まれていたら読み込み、＋１した値を書き込む
  EEPROM.get( 4 , i );
  Serial.print( "4番地の値は " );
  Serial.print( i );
  Serial.println( " です。" );

  i++;
  EEPROM.put( 4 , i );    // 4番地　データ　書き込み　次実行すると値は＋１されている
}

void loop() {
  // 何もしない
}