//**************************************************************************
// ﾌｧｲﾙ内容     「interrupt_1ms.ino」1msごとの割り込み(RMC-RA4M1 rev.2.0)
// Copyright    ジャパンマイコンカーラリー実行委員会
// ライセンス   This software is released under the MIT License.
//              http://opensource.org/licenses/mit-license.php
//**************************************************************************

//  インクルード宣言
#include "FspTimer.h"

// プロトタイプ宣言
void AGTCallback(timer_callback_args_t __attribute((unused)) * p_args);

// グローバル変数の宣言
FspTimer fsp_timer;       // 割り込み関係
unsigned long cnt;

void setup() {
  pinMode( 23, OUTPUT ); // LED D2
  pinMode( 13, OUTPUT ); // LED D3

  // AGT 1msごとの割り込み処理の設定 PCLKB=24MHz ∴TIMER_SOURCE_DIV_1(1分周)なら、1/(24e6*1) * 24000 = 1ms  設定は１小さい値である23999を設定する
  fsp_timer.begin(TIMER_MODE_PERIODIC, AGT_TIMER, 1, 23999, 1, (timer_source_div_t)TIMER_SOURCE_DIV_1, AGTCallback);
  IRQManager::getInstance().addPeripheral(IRQ_AGT, (void*)fsp_timer.get_cfg());
  fsp_timer.open();  
}

void loop() {
  if( cnt >= 1000 ) {
    cnt = 0;
  }
  if( cnt < 500 ) {
    digitalWrite( 23, 1 );
    digitalWrite( 13, 0 );
  } else {
    digitalWrite( 23, 0 );
    digitalWrite( 13, 1 );
  }
}

// 割り込み処理　1msごとに実行
void AGTCallback(timer_callback_args_t __attribute((unused)) * p_args) {
  cnt++;
}
