//**************************************************************************
// ﾌｧｲﾙ内容     A/D変換　連続スキャンモード 制御ライブラリ
// バージョン   Ver.1.01
// Date         2024.02.17
// Copyright    ジャパンマイコンカーラリー実行委員会
// ライセンス   This software is released under the MIT License.
//              http://opensource.org/licenses/mit-license.php
//**************************************************************************

//======================================
// インクルード
//======================================
#include "mcr_ad_lib.h"

//**********************************************************************
// A/D変換　チャンネル（端子）選択
//**********************************************************************
void mcr_ad::useCh( uint8_t ch ) {
  switch( ch ) {
  case 0:
    R_PFS->PORT[0].PIN[0].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[0].PmnPFS_b.ASEL = 1;        // P000=AN000
    R_PFS->PORT[0].PIN[0].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA0 = 1;
    break;

  case 1:
    R_PFS->PORT[0].PIN[1].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[1].PmnPFS_b.ASEL = 1;        // P001=AN001
    R_PFS->PORT[0].PIN[1].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA1 = 1;
    break;

  case 2:
    R_PFS->PORT[0].PIN[2].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[2].PmnPFS_b.ASEL = 1;        // P002=AN002
    R_PFS->PORT[0].PIN[2].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA2 = 1;
    break;

  case 3:
    R_PFS->PORT[0].PIN[3].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[3].PmnPFS_b.ASEL = 1;        // P003=AN003
    R_PFS->PORT[0].PIN[3].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA3 = 1;
    break;

  case 4:
    R_PFS->PORT[0].PIN[4].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[4].PmnPFS_b.ASEL = 1;        // P004=AN004
    R_PFS->PORT[0].PIN[4].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA4 = 1;
    break;

  case 5:
    R_PFS->PORT[0].PIN[10].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[10].PmnPFS_b.ASEL = 1;        // P010=AN005
    R_PFS->PORT[0].PIN[10].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA5 = 1;
    break;

  case 6:
    R_PFS->PORT[0].PIN[11].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[11].PmnPFS_b.ASEL = 1;        // P011=AN006
    R_PFS->PORT[0].PIN[11].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA6 = 1;
    break;

  case 7:
    R_PFS->PORT[0].PIN[12].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[12].PmnPFS_b.ASEL = 1;        // P012=AN007
    R_PFS->PORT[0].PIN[12].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA7 = 1;
    break;

  case 8:
    R_PFS->PORT[0].PIN[13].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[13].PmnPFS_b.ASEL = 1;        // P013=AN008
    R_PFS->PORT[0].PIN[13].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA8 = 1;
    break;

  case 9:
    R_PFS->PORT[0].PIN[14].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[14].PmnPFS_b.ASEL = 1;        // P014=AN009
    R_PFS->PORT[0].PIN[14].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA9 = 1;
    break;

  case 10:
    R_PFS->PORT[0].PIN[15].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[15].PmnPFS_b.ASEL = 1;        // P015=AN010
    R_PFS->PORT[0].PIN[15].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA10 = 1;
    break;

  case 11:
    R_PFS->PORT[0].PIN[5].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[5].PmnPFS_b.ASEL = 1;        // P005=AN011
    R_PFS->PORT[0].PIN[5].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA11 = 1;
    break;

  case 12:
    R_PFS->PORT[0].PIN[6].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[6].PmnPFS_b.ASEL = 1;        // P006=AN012
    R_PFS->PORT[0].PIN[6].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA12 = 1;
    break;

  case 13:
    R_PFS->PORT[0].PIN[7].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[7].PmnPFS_b.ASEL = 1;        // P007=AN013
    R_PFS->PORT[0].PIN[7].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA13 = 1;
    break;

  case 14:
    R_PFS->PORT[0].PIN[8].PmnPFS_b.PMR = 0;
    R_PFS->PORT[0].PIN[8].PmnPFS_b.ASEL = 1;        // P008=AN014
    R_PFS->PORT[0].PIN[8].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[0].ANSA14 = 1;
    break;

  case 15:
    // AN015ありません
    break;

  case 16:
    R_PFS->PORT[5].PIN[0].PmnPFS_b.PMR = 0;
    R_PFS->PORT[5].PIN[0].PmnPFS_b.ASEL = 1;        // P500=AN016
    R_PFS->PORT[5].PIN[0].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[1].ANSA0 = 1;
    break;

  case 17:
    R_PFS->PORT[5].PIN[1].PmnPFS_b.PMR = 0;
    R_PFS->PORT[5].PIN[1].PmnPFS_b.ASEL = 1;        // P501=AN017
    R_PFS->PORT[5].PIN[1].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[1].ANSA1 = 1;
    break;

  case 18:
    R_PFS->PORT[5].PIN[2].PmnPFS_b.PMR = 0;
    R_PFS->PORT[5].PIN[2].PmnPFS_b.ASEL = 1;        // P502=AN018
    R_PFS->PORT[5].PIN[2].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[1].ANSA2 = 1;
    break;

  case 19:
    R_PFS->PORT[1].PIN[3].PmnPFS_b.PMR = 0;
    R_PFS->PORT[1].PIN[3].PmnPFS_b.ASEL = 1;        // P103=AN019
    R_PFS->PORT[1].PIN[3].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[1].ANSA3 = 1;
    break;

  case 20:
    R_PFS->PORT[1].PIN[2].PmnPFS_b.PMR = 0;
    R_PFS->PORT[1].PIN[2].PmnPFS_b.ASEL = 1;        // P102=AN020
    R_PFS->PORT[1].PIN[2].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[1].ANSA4 = 1;
    break;

  case 21:
    R_PFS->PORT[1].PIN[1].PmnPFS_b.PMR = 0;
    R_PFS->PORT[1].PIN[1].PmnPFS_b.ASEL = 1;        // P101=AN021
    R_PFS->PORT[1].PIN[1].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[1].ANSA5 = 1;
    break;

  case 22:
    R_PFS->PORT[1].PIN[0].PmnPFS_b.PMR = 0;
    R_PFS->PORT[1].PIN[0].PmnPFS_b.ASEL = 1;        // P100=AN022
    R_PFS->PORT[1].PIN[0].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[1].ANSA6 = 1;
    break;

  case 23:
    R_PFS->PORT[5].PIN[3].PmnPFS_b.PMR = 0;
    R_PFS->PORT[5].PIN[3].PmnPFS_b.ASEL = 1;        // P503=AN023
    R_PFS->PORT[5].PIN[3].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[1].ANSA7 = 1;
    break;

  case 24:
    R_PFS->PORT[5].PIN[4].PmnPFS_b.PMR = 0;
    R_PFS->PORT[5].PIN[4].PmnPFS_b.ASEL = 1;        // P504=AN024
    R_PFS->PORT[5].PIN[4].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[1].ANSA8 = 1;
    break;

  case 25:
    R_PFS->PORT[5].PIN[5].PmnPFS_b.PMR = 0;
    R_PFS->PORT[5].PIN[5].PmnPFS_b.ASEL = 1;        // P505=AN025
    R_PFS->PORT[5].PIN[5].PmnPFS_b.PMR = 1;         // 0:汎用入出力 1:周辺機能用
    R_ADC0->ADANSA_b[1].ANSA9 = 1;
    break;
  }
}

//**********************************************************************
// A/D変換　スタート
//**********************************************************************
void mcr_ad::start( void ) {
  R_ADC0->ADCSR_b.ADCS = 0b10;  // 連続スキャンモード
  R_ADC0->ADCSR_b.ADST = 1;     // スタート
}

//**********************************************************************
// A/D変換　値取得
//**********************************************************************
int16_t mcr_ad::getData( uint8_t ch ) {
  int ret = -1;

 if( ch <= 25 ) {  // chは符合なしなので　if( ch >= 0 && ch <= 25 )とするとワーニングになる(ch >= 0は当たり前なので)
    ret = R_ADC0->ADDR_b[ch].ADDR;
  }
  return ret;
}

/*
Ver.1.00 2023.09.04 作成
Ver.1.01 2024.02.17 AN023,AN024,AN025のAD変換が正しく動作しないバグを修正
*/

